(load "cvs.scm")

;;;basics

(define context 1)

(define x (make-cv (lambda () context) '((1 . a) (2 . b)) -1))
(cv-ref x)

(define context 2)
(cv-ref x)
(cv-set! x 10)
(cv-ref x)

(define context 1)
(cv-ref x)

(define context 3)
(cv-ref x)
(cv-set! x 'd)
(cv-ref x)

(define context 1)
(cv-ref x)

;;;; thread locals
(define make-tl 
  (lambda (val)
    (make-cv/2 current-thread val)))

(define tl-ref cv-ref)
(define tl-set! cv-set!)

;; example
(define cnp (make-tl "hello"))
(tl-ref cnp) ; => "hello"

(tl-set! cnp "hola")

(define ch (make-channel))
(thread (lambda ()
          (channel-put ch (tl-ref cnp))
          (channel-get ch)
          (tl-set! cnp "bonjour")
          (channel-put ch (tl-ref cnp))))

(channel-get ch) ; => "hello"

(tl-set! cnp "hallo")
(channel-put ch 'ok)
(channel-get ch) ; => "bonjour"
(tl-ref cnp) ; "hallo"

;; context = language setting

(define language "EN")

;; contextual value msg
(define msg (make-cv/2 (lambda () language) "hello"))

;; init for different contexts
(fluid-let ((language "SP"))
  (cv-set! msg "hola"))

(fluid-let ((language "FR"))
  (cv-set! msg "bonjour"))

;; function using context value
(define show-message
  (lambda () (printf "~a~n" (cv-ref msg))))

;; using in different contexts
(show-message)
(fluid-let ((language "FR"))
  (show-message)
  (fluid-let ((language "SP"))
    (show-message))
  (show-message))
(show-message)


